Package org.optaplanner.core.config.heuristic.selector.move

## Class MoveSelectorConfig<Config_ extends MoveSelectorConfig<Config_>>

- java.lang.Object
- - org.optaplanner.core.config.AbstractConfig<Config_>
  - - org.optaplanner.core.config.heuristic.selector.SelectorConfig<Config_>
    - - org.optaplanner.core.config.heuristic.selector.move.MoveSelectorConfig<Config_>

- Direct Known Subclasses:
    `AbstractPillarMoveSelectorConfig`, `CartesianProductMoveSelectorConfig`, `ChangeMoveSelectorConfig`, `KOptMoveSelectorConfig`, `MoveIteratorFactoryConfig`, `MoveListFactoryConfig`, `SubChainChangeMoveSelectorConfig`, `SubChainSwapMoveSelectorConfig`, `SwapMoveSelectorConfig`, `TailChainSwapMoveSelectorConfig`, `UnionMoveSelectorConfig`

      public abstract class MoveSelectorConfig<Config_ extends MoveSelectorConfig<Config_>>
      extends SelectorConfig<Config_>

  General superclass for `ChangeMoveSelectorConfig`, etc.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected SelectionCacheType` | `cacheType` |
    `protected Class<? extends SelectionFilter>` | `filterClass` |
    `protected Class<? extends SelectionProbabilityWeightFactory>` | `probabilityWeightFactoryClass` |
    `protected Long` | `selectedCountLimit` |
    `protected SelectionOrder` | `selectionOrder` |
    `protected Class<? extends SelectionSorter>` | `sorterClass` |
    `protected Class<? extends Comparator>` | `sorterComparatorClass` |
    `protected SelectionSorterOrder` | `sorterOrder` |
    `protected Class<? extends SelectionSorterWeightFactory>` | `sorterWeightFactoryClass` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MoveSelectorConfig()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `extractLeafMoveSelectorConfigsIntoList​(List<MoveSelectorConfig> leafMoveSelectorConfigList)` | Gather a list of all descendant `MoveSelectorConfig`s except for `UnionMoveSelectorConfig` and `CartesianProductMoveSelectorConfig`.
    `SelectionCacheType` | `getCacheType()` |
    `Class<? extends SelectionFilter>` | `getFilterClass()` |
    `Double` | `getFixedProbabilityWeight()` |
    `Class<? extends SelectionProbabilityWeightFactory>` | `getProbabilityWeightFactoryClass()` |
    `Long` | `getSelectedCountLimit()` |
    `SelectionOrder` | `getSelectionOrder()` |
    `Class<? extends SelectionSorter>` | `getSorterClass()` |
    `Class<? extends Comparator>` | `getSorterComparatorClass()` |
    `SelectionSorterOrder` | `getSorterOrder()` |
    `Class<? extends SelectionSorterWeightFactory>` | `getSorterWeightFactoryClass()` |
    `Config_` | `inherit​(Config_ inheritedConfig)` | Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).
    `void` | `inheritFolded​(MoveSelectorConfig<Config_> foldedConfig)` | Does not inherit subclass properties because this class and `foldedConfig` can be of a different type.
    `void` | `setCacheType​(SelectionCacheType cacheType)` |
    `void` | `setFilterClass​(Class<? extends SelectionFilter> filterClass)` |
    `void` | `setFixedProbabilityWeight​(Double fixedProbabilityWeight)` |
    `void` | `setProbabilityWeightFactoryClass​(Class<? extends SelectionProbabilityWeightFactory> probabilityWeightFactoryClass)` |
    `void` | `setSelectedCountLimit​(Long selectedCountLimit)` |
    `void` | `setSelectionOrder​(SelectionOrder selectionOrder)` |
    `void` | `setSorterClass​(Class<? extends SelectionSorter> sorterClass)` |
    `void` | `setSorterComparatorClass​(Class<? extends Comparator> sorterComparatorClass)` |
    `void` | `setSorterOrder​(SelectionSorterOrder sorterOrder)` |
    `void` | `setSorterWeightFactoryClass​(Class<? extends SelectionSorterWeightFactory> sorterWeightFactoryClass)` |
    `MoveSelectorConfig<Config_>` | `withCacheType​(SelectionCacheType cacheType)` |
    `MoveSelectorConfig<Config_>` | `withFilterClass​(Class<? extends SelectionFilter> filterClass)` |
    `MoveSelectorConfig<Config_>` | `withFixedProbabilityWeight​(Double fixedProbabilityWeight)` |
    `MoveSelectorConfig<Config_>` | `withProbabilityWeightFactoryClass​(Class<? extends SelectionProbabilityWeightFactory> probabilityWeightFactoryClass)` |
    `MoveSelectorConfig<Config_>` | `withSelectedCountLimit​(Long selectedCountLimit)` |
    `MoveSelectorConfig<Config_>` | `withSelectionOrder​(SelectionOrder selectionOrder)` |
    `MoveSelectorConfig<Config_>` | `withSorterClass​(Class<? extends SelectionSorter> sorterClass)` |
    `MoveSelectorConfig<Config_>` | `withSorterComparatorClass​(Class<? extends Comparator> sorterComparatorClass)` |
    `MoveSelectorConfig<Config_>` | `withSorterOrder​(SelectionSorterOrder sorterOrder)` |
    `MoveSelectorConfig<Config_>` | `withSorterWeightFactoryClass​(Class<? extends SelectionSorterWeightFactory> sorterWeightFactoryClass)` |

    - ### Methods inherited from class org.optaplanner.core.config.AbstractConfig

      `copyConfig, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### cacheType

          protected SelectionCacheType cacheType

    - #### selectionOrder

          protected SelectionOrder selectionOrder

    - #### filterClass

          protected Class<? extends SelectionFilter> filterClass

    - #### sorterComparatorClass

          protected Class<? extends Comparator> sorterComparatorClass

    - #### sorterWeightFactoryClass

          protected Class<? extends SelectionSorterWeightFactory> sorterWeightFactoryClass

    - #### sorterOrder

          protected SelectionSorterOrder sorterOrder

    - #### sorterClass

          protected Class<? extends SelectionSorter> sorterClass

    - #### probabilityWeightFactoryClass

          protected Class<? extends SelectionProbabilityWeightFactory> probabilityWeightFactoryClass

    - #### selectedCountLimit

          protected Long selectedCountLimit

  - ### Constructor Detail

    - #### MoveSelectorConfig

          public MoveSelectorConfig()

  - ### Method Detail

    - #### getCacheType

          public SelectionCacheType getCacheType()

    - #### setCacheType

          public void setCacheType​(SelectionCacheType cacheType)

    - #### getSelectionOrder

          public SelectionOrder getSelectionOrder()

    - #### setSelectionOrder

          public void setSelectionOrder​(SelectionOrder selectionOrder)

    - #### getFilterClass

          public Class<? extends SelectionFilter> getFilterClass()

    - #### setFilterClass

          public void setFilterClass​(Class<? extends SelectionFilter> filterClass)

    - #### getSorterComparatorClass

          public Class<? extends Comparator> getSorterComparatorClass()

    - #### setSorterComparatorClass

          public void setSorterComparatorClass​(Class<? extends Comparator> sorterComparatorClass)

    - #### getSorterWeightFactoryClass

          public Class<? extends SelectionSorterWeightFactory> getSorterWeightFactoryClass()

    - #### setSorterWeightFactoryClass

          public void setSorterWeightFactoryClass​(Class<? extends SelectionSorterWeightFactory> sorterWeightFactoryClass)

    - #### getSorterOrder

          public SelectionSorterOrder getSorterOrder()

    - #### setSorterOrder

          public void setSorterOrder​(SelectionSorterOrder sorterOrder)

    - #### getSorterClass

          public Class<? extends SelectionSorter> getSorterClass()

    - #### setSorterClass

          public void setSorterClass​(Class<? extends SelectionSorter> sorterClass)

    - #### getProbabilityWeightFactoryClass

          public Class<? extends SelectionProbabilityWeightFactory> getProbabilityWeightFactoryClass()

    - #### setProbabilityWeightFactoryClass

          public void setProbabilityWeightFactoryClass​(Class<? extends SelectionProbabilityWeightFactory> probabilityWeightFactoryClass)

    - #### getSelectedCountLimit

          public Long getSelectedCountLimit()

    - #### setSelectedCountLimit

          public void setSelectedCountLimit​(Long selectedCountLimit)

    - #### getFixedProbabilityWeight

          public Double getFixedProbabilityWeight()

    - #### setFixedProbabilityWeight

          public void setFixedProbabilityWeight​(Double fixedProbabilityWeight)

    - #### withCacheType

          public MoveSelectorConfig<Config_> withCacheType​(SelectionCacheType cacheType)

    - #### withSelectionOrder

          public MoveSelectorConfig<Config_> withSelectionOrder​(SelectionOrder selectionOrder)

    - #### withFilterClass

          public MoveSelectorConfig<Config_> withFilterClass​(Class<? extends SelectionFilter> filterClass)

    - #### withSorterComparatorClass

          public MoveSelectorConfig<Config_> withSorterComparatorClass​(Class<? extends Comparator> sorterComparatorClass)

    - #### withSorterWeightFactoryClass

          public MoveSelectorConfig<Config_> withSorterWeightFactoryClass​(Class<? extends SelectionSorterWeightFactory> sorterWeightFactoryClass)

    - #### withSorterOrder

          public MoveSelectorConfig<Config_> withSorterOrder​(SelectionSorterOrder sorterOrder)

    - #### withSorterClass

          public MoveSelectorConfig<Config_> withSorterClass​(Class<? extends SelectionSorter> sorterClass)

    - #### withProbabilityWeightFactoryClass

          public MoveSelectorConfig<Config_> withProbabilityWeightFactoryClass​(Class<? extends SelectionProbabilityWeightFactory> probabilityWeightFactoryClass)

    - #### withSelectedCountLimit

          public MoveSelectorConfig<Config_> withSelectedCountLimit​(Long selectedCountLimit)

    - #### withFixedProbabilityWeight

          public MoveSelectorConfig<Config_> withFixedProbabilityWeight​(Double fixedProbabilityWeight)

    - #### extractLeafMoveSelectorConfigsIntoList

          public void extractLeafMoveSelectorConfigsIntoList​(List<MoveSelectorConfig> leafMoveSelectorConfigList)

      Gather a list of all descendant `MoveSelectorConfig`s except for `UnionMoveSelectorConfig` and `CartesianProductMoveSelectorConfig`.
      Parameters:
        `leafMoveSelectorConfigList` - not null

    - #### inherit

          public Config_ inherit​(Config_ inheritedConfig)

      Description copied from class: `AbstractConfig`
      Inherits each property of the `inheritedConfig` unless that property (or a semantic alternative) is defined by this instance (which overwrites the inherited behaviour).

      After the inheritance, if a property on this `AbstractConfig` composition is replaced, it should not affect the inherited composition instance.

      Specified by:
        `inherit` in class `AbstractConfig<Config_ extends MoveSelectorConfig<Config_>>`
      Parameters:
        `inheritedConfig` - never null
      Returns:
        this

    - #### inheritFolded

          public void inheritFolded​(MoveSelectorConfig<Config_> foldedConfig)

      Does not inherit subclass properties because this class and `foldedConfig` can be of a different type.
      Parameters:
        `foldedConfig` - never null